---------
--AWACS--
---------

--create zones in ME

-- Common zones
local Zone={}
Zone.BlueAWACS   = ZONE:New("Zone Blue AWACS")   --Core.Zone#ZONE --Blue AWACS zone
Zone.RedAWACS   = ZONE:New("Zone Red AWACS")   --Core.Zone#ZONE --Red AWACS zone
Zone.BlueTANKER = ZONE:New("Zone Blue TANKER") --Core.Zone#ZONE --Blue Tanker zone
-- Zone.Delta   = ZONE:New("Zone Delta")   --Core.Zone#ZONE --not used
-- Set of all zones defined in the ME
local AllZones=SET_ZONE:New():FilterOnce()

--In ME: 
--create AWACS a/c "Blue AWACS A"
--no waypoints reqd
--takeoff from parking cold or hot, runway, or in the air
--for delayed ground starts from ramp cold: check uncontrolled / triggered actions - perform command: start
--for delayed air starts: check late activation
--advanced waypoint actions--
--start enroute task--AWACS

-- @param Core.Point#COORDINATE Coordinate Where to orbit. Altitude is also taken from the coordinate.
-- @param #number Altitude Orbit altitude in feet. Default is y component of `Coordinate`.
-- @param #number Speed Orbit speed in knots. Default 350 kts.
-- @param #number Heading Heading of race-track pattern in degrees. Default 270 (East to West).
-- @param #number Leg Length of race-track in NM. Default 10 NM.
-- AUFTRAG:NewAWACS(Coordinate, Altitude, Speed, Heading, Leg)

-- AUFTRAG: AWACS
-- Create an AWACS patrolling at Zone XXX
-- Callsign Darkstar 5-1
-- Radio 225 MHz AM

local auftrag=AUFTRAG:NewAWACS(Zone.BlueAWACS:GetCoordinate(), 35000, 350, 045, 15)
local awacs1=FLIGHTGROUP:New("Blue AWACS") --using this AWACS aircraft for intercept tasking script with other radars thus EWR vs AWACS prefix
auftrag:SetRadio(264)
awacs1:SetDefaultCallsign(CALLSIGN.AWACS.Darkstar, 5)
awacs1:AddMission(auftrag)

local auftrag=AUFTRAG:NewAWACS(Zone.RedAWACS:GetCoordinate(), 35000, 350, 090, 15)
local awacs2=FLIGHTGROUP:New("Red AWACS")
-- auftrag:SetRadio(225)
-- awacs2:SetDefaultCallsign(CALLSIGN.AWACS.Darkstar, 5)
awacs2:AddMission(auftrag)

----------
--Tanker--
----------
--In ME: 
--create AWACS a/c "TANKER A"
--no waypoints reqd
--takeoff from parking cold or hot, runway, or in the air
--for delayed ground starts from ramp cold: check uncontrolled / triggered actions - perform command: start
--for delayed air starts: check late activation
--advanced waypoint actions--
--start enroute task--Refueling

-- @param #number Altitude Orbit altitude in feet. Default is y component of `Coordinate`.
-- @param #number Speed Orbit speed in knots. Default 350 kts.
-- @param #number Heading Heading of race-track pattern in degrees. Default 270 (East to West).
-- @param #number Leg Length of race-track in NM. Default 10 NM.
-- @param #number RefuelSystem Refueling system (0=boom, 1=probe). This info is *only* for AIRWINGs so they launch the right tanker type.
-- @return #AUFTRAG self
-- AUFTRAG:NewTANKER(Coordinate, Altitude, Speed, Heading, Leg, RefuelSystem)

local auftrag=AUFTRAG:NewTANKER(Zone.BlueTANKER:GetCoordinate(), 25000, 350, 270, 30)
  auftrag:SetTACAN(80, "ARC")
  auftrag:SetRadio(265)
  local tanker1=FLIGHTGROUP:New("Blue TANKER A")
  tanker1:SetDefaultCallsign(CALLSIGN.Tanker.Arco, 5)
  tanker1:AddMission(auftrag)








