--------------------
-- Air operations --
--------------------


-- Common zones
local Zone={}
Zone.RedCAP1	= ZONE:New("Zone Red CAP 1")   	--Core.Zone#ZONE --CAP zone
Zone.RedCAP2	= ZONE:New("Zone Red CAP 2")   	--Core.Zone#ZONE --CAP zone
Zone.RedEWR1	= ZONE:New("Zone RedEWR1") 		--Core.Zone#ZONE --EWR
Zone.RedEWR2	= ZONE:New("Zone RedEWR2")   	--Core.Zone#ZONE --EWR
Zone.RedEWR3	= ZONE:New("Zone RedEWR3") 		--Core.Zone#ZONE --EWR
Zone.BlueCAP1	= ZONE:New("Zone Blue CAP 1")	--Core.Zone#ZONE --CAP zone
-- Set of all zones defined in the ME
local AllZones=SET_ZONE:New():FilterOnce()



-- CREATE SQUADRONS
-- SQUADRON:New(TemplateGroupName, Ngroups, SquadronName)
-- Set livery painted on all squadron aircraft.
-- Note that the livery name in general is different from the name shown in the mission editor.
-- Valid names are the names of the **livery directories**. Check out the folder in your DCS installation for:
-- * Full modules: `DCS World OpenBeta\CoreMods\aircraft\<Aircraft Type>\Liveries\<Aircraft Type>\<Livery Name>`
-- * AI units: `DCS World OpenBeta\Bazar\Liveries\<Aircraft Type>\<Livery Name>`
-- 
-- The folder name `<Livery Name>` is the string you want.

-- Red team --

--SU25T squadron 1
squadron1=SQUADRON:New("Red Ground A", 12, "Red Ground A") --Ops.Squadron#SQUADRON
 squadron1:SetLivery("Algerian AF Desert KU-03")
 squadron1:SetSkill(AI.Skill.HIGH)
 squadron1:SetGrouping(1)
 squadron1:SetModex(87, nil, nil)
 squadron1:SetMissionRange(300)
 squadron1:AddMissionCapability({AUFTRAG.Type.BAI, AUFTRAG.Type.SEAD}, 100)
 
--Mig 29a squadron 1
squadron2=SQUADRON:New("Red Intercept B", 24, "Red Intercept B") --Ops.Squadron#SQUADRON 
 squadron2:SetLivery("IRIAF Blue-Grey")
 squadron2:SetSkill(AI.Skill.AVERAGE)
 squadron2:SetGrouping(1)
 squadron2:SetModex(77, nil, nil)
 squadron2:SetMissionRange(300)
 squadron2:AddMissionCapability({AUFTRAG.Type.CAP, AUFTRAG.Type.INTERCEPT}, 100) 

-- Blue Team --
--F22 squadron Al Minhad AFB
squadronA=SQUADRON:New("1st Starscream", 12, "1st Starscream") --Ops.Squadron#SQUADRON
 squadronA:SetCallsign(CALLSIGN.Aircraft.Chevy)
 squadronA:SetRadio(305)
 squadronA:SetLivery("Starscream")
 squadronA:SetSkill(AI.Skill.HIGH)
 squadronA:SetGrouping(1)
 squadronA:SetVerbosity(2) 
 squadronA:AddMissionCapability({AUFTRAG.Type.CAP, AUFTRAG.Type.INTERCEPT, AUFTRAG.Type.ESCORT}, 100)
 
--F22 squadron Fujairah
squadronB=SQUADRON:New("2nd Starscream", 6, "2nd Starscream") --Ops.Squadron#SQUADRON 
 squadronB:SetCallsign(CALLSIGN.Aircraft.Dodge)
 squadronB:SetRadio(305)
 squadronB:SetLivery("Starscream")
 squadronB:SetSkill(AI.Skill.HIGH)
 squadronB:SetGrouping(1)
 squadronB:SetVerbosity(2) 
 squadronB:AddMissionCapability({AUFTRAG.Type.CAP, AUFTRAG.Type.INTERCEPT}, 100) 

--F15C squadron Al Minhad
squadronC=SQUADRON:New("1st Ferris", 12, "1st Ferris") --Ops.Squadron#SQUADRON 
 squadronC:SetCallsign(CALLSIGN.Aircraft.Uzi)
 squadronC:SetRadio(305)
 squadronC:SetLivery("Ferris Scheme")
 squadronC:SetSkill(AI.Skill.HIGH)
 squadronC:SetGrouping(1)
 squadronC:SetModex(61, nil, nil)
 squadronC:SetVerbosity(2)
 squadronC:SetMissionRange(300) 
 squadronC:AddMissionCapability({AUFTRAG.Type.CAP, AUFTRAG.Type.INTERCEPT}, 100)
 


--Ops.AirWing#AIRWING
-- Create AIRWINGS - note these are warehouses and in the case of ships, the ship name
-- @param #string warehousename Name of the warehouse static or unit object representing the warehouse.
-- @param #string airwingname Name of the air wing, e.g. "AIRWING-8".
-- function AIRWING:New(warehousename, airwingname)

-- Red Team --
hangar1=AIRWING:New("Hangar SU25T", "Hangar SU25T")
hangar2=AIRWING:New("Hangar MIG29A", "Hangar MIG29A") 

-- Blue Team --
hangarA=AIRWING:New("Hangar 1st F22", "Hangar 1st F22")
hangarA:SetParkingIDs({10,11,12,13,23,28}) 
hangarB=AIRWING:New("Hangar 2nd F22", "Hangar 2nd F22")
hangarB:SetParkingIDs({10,11,12,13})
hangarC=AIRWING:New("Hangar 1st F15C", "Hangar 1st F15C")
hangarC:SetParkingIDs({14,15,16,17,18,19,20,21,22})

-- Add squadrons to airwing.

-- Red Team --
hangar1:AddSquadron(squadron1)
hangar2:AddSquadron(squadron2)

-- Blue Team --
hangarA:AddSquadron(squadronA)
hangarB:AddSquadron(squadronB)
hangarC:AddSquadron(squadronC)

-- PAYLOADS (multiples can be made)
-- In Mission Editor: select late activation
-- @param Wrapper.Unit#UNIT Unit The unit, the payload is extracted from. Can also be given as *#string* name of the unit.
-- @param #number Npayloads Number of payloads to add to the airwing resources. Default 99 (which should be enough for most scenarios). Set to -1 for unlimited.
-- @param #table MissionTypes Mission types this payload can be used for.
-- @param #number Performance A number between 0 (worst) and 100 (best) to describe the performance of the loadout for the given mission types. Default is 50.
-- @return #AIRWING.Payload The payload table or nil if the unit does not exist.
-- function AIRWING:NewPayload(Unit, Npayloads, MissionTypes,  Performance)

-- Red Team --
local SU25TCAS=hangar1:NewPayload(GROUP:FindByName("Red Ground A BAI"), 20, {AUFTRAG.Type.BAI,AUFTRAG.Type.CAS}, 100)
local SU25TSEAD=hangar1:NewPayload(GROUP:FindByName("Red Ground A SEAD"), 20, {AUFTRAG.Type.SEAD}, 100)
local MIG29ACAP=hangar2:NewPayload(GROUP:FindByName("Red Intercept B CAP"), 40, {AUFTRAG.Type.CAP, AUFTRAG.Type.INTERCEPT}, 100)

-- Blue Team --
local F22INT1ST=hangarA:NewPayload(GROUP:FindByName("1st Starscream INTERCEPT"), 40, {AUFTRAG.Type.CAP}, 100)
local F22INT2ND=hangarB:NewPayload(GROUP:FindByName("2nd Starscream INTERCEPT"), 40, {AUFTRAG.Type.CAP}, 100)
local F15CINT1ST=hangarC:NewPayload(GROUP:FindByName("1st Ferris INTERCEPT"), 40, {AUFTRAG.Type.CAP}, 100)

-- Start the Airwings

-- Red Team --
hangar1:Start()
hangar2:Start()

-- Blue Team --
hangarA:Start()
hangarB:Start()
hangarC:Start()

-- SETUP mission start flights
-- function AUFTRAG:NewCAP(ZoneCAP,Altitude,Speed,Coordinate,Heading,Leg,TargetTypes)

-- Red Team --
local auftrag = AUFTRAG:NewCAP(Zone.RedCAP1, 25000, 275, nil, 360, 15, nil)
auftrag:SetTime( 5 , 45*60 )
auftrag:SetRequiredAssets(2)
auftrag:SetRepeatOnFailure(99) --if flights are shot down another flight will launch until inventory is exhausted
hangar2:AddMission(auftrag)

local auftrag = AUFTRAG:NewCAP(Zone.RedCAP2, 25000, 275, nil, 360, 15, nil)
auftrag:SetTime( 5 , 45*60 )
auftrag:SetRequiredAssets(2)
auftrag:SetRepeatOnFailure(99) --if flights are shot down another flight will launch until inventory is exhausted
hangar2:AddMission(auftrag)

-- Blue Team --
local auftrag = AUFTRAG:NewCAP(Zone.BlueCAP1, 25000, 300, nil, 180, 15, nil)
auftrag:SetWeaponExpend(AI.Task.WeaponExpend.ONE)
auftrag:SetRequiredAssets(2)
auftrag:SetTime( 60 , 35*60 )
hangarA:AddMission(auftrag)



-- Units on ground or in the air will provide INTEL for each coalition

-- Create a SET of all Red Groups
local redAgentSet=SET_GROUP:New():FilterCoalitions("red"):FilterStart()

-- Declare an INTEL based off that SET, for RED coalition
local kgb=INTEL:New(redAgentSet, coalition.side.RED)  
kgb:AddAcceptZone(ZONE_POLYGON:NewFromGroupName("Red Ops Area")) --give it an inclusive area  
kgb:Start() --start it

-- Create a SET of all Blue Groups
local blueAgentSet=SET_GROUP:New():FilterCoalitions("blue"):FilterStart()

-- Declare an INTEL based off that SET, for BLUE coalition
local cia=INTEL:New(blueAgentSet, coalition.side.BLUE)  
cia:AddAcceptZone(ZONE_POLYGON:NewFromGroupName("Red Ops Area")) --give it an inclusive area  
cia:Start() --start it


-- functions for the F10 menu Blue tasking requests
-- https://wiki.hoggitworld.com/view/DCS_enum_attributes for target attributes

function f22MINintercept()
MESSAGE:New("MIN AFB: F22 intercept request received", 30):ToAll()
local auftrag = AUFTRAG:NewCAP(Zone.BlueCAP1, 27000, 300, nil, 180, 15, nil)
auftrag:SetTime( 5 , 45*60 )
auftrag:SetRequiredAssets(2)
hangarA:AddMission(auftrag) --blue hangerA f22 al minhad
end

function f15MINintercept()
MESSAGE:New("MIN AFB: F15 intercept request received", 30):ToAll()
local auftrag = AUFTRAG:NewCAP(Zone.BlueCAP1, 27000, 300, nil, 180, 15, nil)
auftrag:SetTime( 5 , 45*60 )
auftrag:SetRequiredAssets(2)
hangarC:AddMission(auftrag) --blue hangerA f15c al minhad
end

function f22FUJintercept()
MESSAGE:New("SHA AFB: F22 intercept request received", 30):ToAll()
local auftrag = AUFTRAG:NewCAP(Zone.BlueCAP1, 27000, 300, nil, 180, 15, nil)
auftrag:SetTime( 5 , 45*60 )
auftrag:SetRequiredAssets(2)
hangarB:AddMission(auftrag) --blue hangerB f22 fujairah
end

function seadwest()
MESSAGE:New("SEAD attack request received (Bandar Legeh)", 30):ToAll()
local seadEWR1=FLIGHTGROUP:New("Blue SEAD1")
seadEWR1:SetDefaultCallsign(CALLSIGN.Aircraft.Colt,1)
local ewr1=AUFTRAG:NewCAS(Zone.RedEWR1, nil, nil, nil, nil, nil, nil)
ewr1:SetRadio(264)
ewr1:SetFormation(393218) -- finger four open https://wiki.hoggitworld.com/view/DCS_enum_formation
ewr1:SetTime( 1, 20*60 )
seadEWR1:AddMission(ewr1)

function ewr1:OnAfterDone()
  seadEWR1:RTB(AIRBASE:FindByName(AIRBASE.PersianGulf.Al_Minhad_AB))
  end

local escortEWR1=FLIGHTGROUP:New("Blue Escort1")
escortEWR1:SetDefaultCallsign(CALLSIGN.Aircraft.Colt,2)
local escort1=AUFTRAG:NewESCORT(seadEWR1:GetGroup(), {x=-1000, y=300, z=1000}, 32)
escort1:SetRadio(264)
escort1:SetFormation(393218)  
escort1:SetTime( 10 )
escortEWR1:AddMission(escort1)

function escort1:OnAfterDone()
  escortEWR1:RTB(AIRBASE:FindByName(AIRBASE.PersianGulf.Al_Minhad_AB))
  end
  
function ewr1:onafterStarted(From, Event, To)
  Menu4:Remove()
  end

end

function seadcenter()
MESSAGE:New("SEAD attack request received (Qeshm Island)", 30):ToAll()
local seadEWR2=FLIGHTGROUP:New("Blue SEAD2")
seadEWR2:SetDefaultCallsign(CALLSIGN.Aircraft.Colt,3)
local ewr2=AUFTRAG:NewCAS(Zone.RedEWR2, nil, nil, nil, nil, nil, nil)
ewr2:SetRadio(264)
ewr2:SetFormation(393218)
ewr2:SetTime( 1, 20*60 )
seadEWR2:AddMission(ewr2)

function ewr2:OnAfterDone()
  seadEWR2:RTB(AIRBASE:FindByName(AIRBASE.PersianGulf.Al_Minhad_AB))
  end

local escortEWR2=FLIGHTGROUP:New("Blue Escort2")
escortEWR2:SetDefaultCallsign(CALLSIGN.Aircraft.Colt,4)
local escort2=AUFTRAG:NewESCORT(seadEWR2:GetGroup(), {x=-1000, y=300, z=1000}, 32)
escort2:SetRadio(264)
escort2:SetFormation(393218)
escort2:SetTime( 10 )
escortEWR2:AddMission(escort2)

function escort2:OnAfterDone()
  escortEWR2:RTB(AIRBASE:FindByName(AIRBASE.PersianGulf.Al_Minhad_AB))
  end
  
function ewr2:onafterStarted(From, Event, To)
  Menu5:Remove()
  end
  
end

function seadeast()
MESSAGE:New("SEAD attack request received (Bandar Abbas)", 30):ToAll()
local seadEWR3=FLIGHTGROUP:New("Blue SEAD3")
seadEWR3:SetDefaultCallsign(CALLSIGN.Aircraft.Colt,5)
local ewr3=AUFTRAG:NewCAS(Zone.RedEWR3, nil, nil, nil, nil, nil, nil)
ewr3:SetRadio(264)
ewr3:SetFormation(393218)
ewr3:SetTime( 1, 25*60 )
seadEWR3:AddMission(ewr3)

function ewr3:OnAfterDone()
  seadEWR3:RTB(AIRBASE:FindByName(AIRBASE.PersianGulf.Al_Minhad_AB))
  end

local escortEWR3=FLIGHTGROUP:New("Blue Escort3")
escortEWR3:SetDefaultCallsign(CALLSIGN.Aircraft.Colt,6)
local escort3=AUFTRAG:NewESCORT(seadEWR3:GetGroup(), {x=-1000, y=300, z=1000}, 32)
escort3:SetRadio(264)
escort3:SetFormation(393218)
escort3:SetTime( 10 )
escortEWR3:AddMission(escort3)

function escort3:OnAfterDone()
  escortEWR3:RTB(AIRBASE:FindByName(AIRBASE.PersianGulf.Al_Minhad_AB))
  end
  
function ewr3:onafterStarted(From, Event, To)
  Menu6:Remove()
  end

end



-- --TOP MENU
TopMenu1 = MENU_MISSION:New( "Air tasking request" )

-- --FIRST SUB MENU
Menu1 = MENU_MISSION_COMMAND:New("MIN AFB F22: Request intercept", TopMenu1, f22MINintercept)
Menu2 = MENU_MISSION_COMMAND:New("SHA AFB F22: Request intercept", TopMenu1, f22FUJintercept)
Menu3 = MENU_MISSION_COMMAND:New("MIN AFB F15: Request intercept", TopMenu1, f15MINintercept)
Menu4 = MENU_MISSION_COMMAND:New("MIN AFB: Execute SEAD attack (Bandar Legeh)", TopMenu1, seadwest)
Menu5 = MENU_MISSION_COMMAND:New("MIN AFB: Execute SEAD attack (Qeshm Island)", TopMenu1, seadcenter)
Menu6 = MENU_MISSION_COMMAND:New("MIN AFB: Execute SEAD attack (Bandar Abbas)", TopMenu1, seadeast)


--THIS FUNCTION WILL TO CREATE A MISSION FOR ALL DETECTIONS OF THE RIGHT TYPE

-- Red Team --
function redATO(contact) 

if (contact.attribute == "Air_Fighter") or (contact.attribute == "Air_Bomber") then

    local airtgthanger2=GROUP:FindByName(contact.groupname) --red hanger2 mig29a
    local auftrag=AUFTRAG:NewINTERCEPT(airtgthanger2)
	auftrag:SetRequiredAssets(2)
    hangar2:AddMission(auftrag)

elseif (contact.attribute == "Ground_SAM") or (contact.attribute == "Ground_AAA") or (contact.attribute == "Ground_EWR") then

    local tgthanger1=GROUP:FindByName(contact.groupname) --red hanger1 su25T
    local auftrag=AUFTRAG:NewSEAD(tgthanger1, 8000)
	auftrag:SetRepeatOnFailure(99)
	hangar1:AddMission(auftrag)
  
end

end --endfunc



--- Function called when a NEW contact is detected.
function kgb:OnAfterNewContact(From, Event, To, Contact)
  local contact=Contact --Ops.Intelligence#INTEL.Contact
  redATO(contact) --fire the function for the contact  
end --end OnAfterNew

--- Function called when a NEW contact is detected.
-- function cia:OnAfterNewContact(From, Event, To, Contact)
  -- local contact=Contact --Ops.Intelligence#INTEL.Contact
  -- blueATO(contact) --fire the function for the contact  
-- end --end OnAfterNew


